#!/usr/bin/python
import sys
import os
from BeautifulSoup import BeautifulSoup

#4.5 - 6 inches
#1000 steps per inch
#scaling factor approx = 10
docWidth = 5000.0
docHeight = 4000.0
docAspect = docWidth/docHeight
#SETTINGS
lineInterval = 1 # (li) integers only, distance between lines
filterSize = 10 # (fs) integers only - 'size' of dark regions
threshold = .49 # (trs) lower == lighter, higher == darker
"""
GOOD SETTINGS
li = 1, fs = 4, trs = .5 'normal'
li = 2, fs = 48, trs = .45 'arty/aggressive/peter'
li = 1, fs = 48, trs = .43 'Brian'
"""
def main():
	tmpName = "/tmp/drawBot"
	if len(sys.argv) != 2:
		print "Usage: bmpToAvsPoints.py [infile]"
		sys.exit(-1)
	os.system("mkbitmap -x -t %f -f %i -o mkb.pbm %s" % (threshold, filterSize, sys.argv[1]))
	os.system("potrace -t 100 -k .45 -d 1 -o pot.svg -b svg mkb.pbm ")
	raw_input("Press <RETURN> to continue")
	infile = file("pot.svg", "r")
	outfile = file(tmpName, "w")
	data = BeautifulSoup(infile)
	paths = data.findAll("path")
	print "Found %i paths" %(len(paths))

	sfac = 1.0
	xoff = 0.0
	yoff = 0.0
	#figure out where the image is.
	#rebase and scale
	xmin = ymin = 1000000000.0 
	xmax = ymax = 0.0
	for path in paths:
		svgdata = path['d'].split()
		currentPos = (0,0)
		for i in range(0,len(svgdata),2):
			if "M" == svgdata[i][0]:
				currentPos = (int(svgdata[i][1:]), int(svgdata[i+1]))
			elif "m" == svgdata[i][0]:
				currentPos = (currentPos[0] + int(svgdata[i][1:]), currentPos[1] + int(svgdata[i+1]))
			elif "l" == svgdata[i][0]:
				currentPos = (currentPos[0] + int(svgdata[i][1:]), currentPos[1] + int(svgdata[i+1]))
			else:
				lineEnd = False
				if ("z" == svgdata[i+1][-1]):
					svgdata[i+1] = svgdata[i+1][0:-1]
					lineEnd = True
				oldPos = currentPos
				currentPos = (currentPos[0] + int(svgdata[i]), currentPos[1] + int(svgdata[i+1]))
			if currentPos[0] > xmax:
				xmax = currentPos[0]
			if currentPos[0] < xmin:
				xmin = currentPos[0]
			if currentPos[1] > ymax:
				ymax = currentPos[1]
			if currentPos[1] < ymin:
				ymin = currentPos[1]
	inputWidth = float(xmax-xmin)
	inputHeight = float(ymax-ymin)
	inputAspect = inputWidth/inputHeight

	#the input is wide with respect to out surface, so scale based on x
	if inputAspect >= docAspect:
		sfac = docWidth/inputWidth
	else: #the input is 
		sfac = docHeight/inputHeight
	
	xoff = -xmin*sfac
	yoff = -ymin*sfac

	print "Original Size: %i %i" %(inputWidth, inputHeight)
	print "Scaling Factor: %f" %(sfac)
	
	lineSegments = 0
	#we understand M,m,and l
	for path in paths:
		svgdata = path['d'].split()
		curreyyntPos = (0,0)
		for i in range(0,len(svgdata),2):
			if "M" == svgdata[i][0]:
				currentPos = (int(svgdata[i][1:]), int(svgdata[i+1]))
			elif "m" == svgdata[i][0]:
				currentPos = (currentPos[0] + int(svgdata[i][1:]), currentPos[1] + int(svgdata[i+1]))
			elif "l" == svgdata[i][0]:
				outfile.write("%i,%i\n" % (currentPos[0]*sfac + xoff, currentPos[1]*sfac + yoff))
				oldPos = currentPos
				currentPos = (currentPos[0] + int(svgdata[i][1:]), currentPos[1] + int(svgdata[i+1]))
				outfile.write("%i,%i\n" % (currentPos[0]*sfac + xoff, currentPos[1]*sfac + yoff))
				lineSegments += 1
			else:
				lineEnd = False
				if ("z" == svgdata[i+1][-1]):
					svgdata[i+1] = svgdata[i+1][0:-1]
					lineEnd = True
				oldPos = currentPos
				currentPos = (currentPos[0] + int(svgdata[i]), currentPos[1] + int(svgdata[i+1]))
				lineSegments += 1
				if lineEnd:
					outfile.write("%i,%i\n\n" % (currentPos[0]*sfac + xoff, currentPos[1]*sfac + yoff))
				else:
					outfile.write("%i,%i\n" % (currentPos[0]*sfac + xoff, currentPos[1]*sfac + yoff))
	outfile.write("s")
	outfile.close()
	print "Found %i line segments" % (lineSegments)
	os.system("drawbotShader pot.svg %s.png %s %i" % (tmpName, tmpName, lineInterval))
	print "Connecting to drawbot!"
	os.system("nc 192.168.0.200 2112 < %s" % (tmpName)) 
	
main()


"""
COOL STUFF:
Simple test image and printouts of lots of 'thumbnails' w/ different settings
More shading algorithms/variations
Unify shading/outlines
come up with better way to create shading data
"""